// LaunchZBrush.cpp : Defines the entry point for the console application.
//

#include <windows.h>
#include "stdafx.h"
#include <shellapi.h>
#include <string>
#include <iostream>
#include <fstream>

using namespace std;

wstring FileNameExtract(const wstring& str, int mode)//(1=path, 2=name, 4=ext)
{
	size_t found;
	wstring newStr;
	switch (mode)
	{
	case 1:
		found = str.find_last_of(L"/\\");
		return str.substr(0, found + 1);
		break;

	case 2:
		found = str.find_last_of(L"/\\");
		newStr = str.substr(found + 1);
		found = newStr.find_last_of(L".");
		return newStr.substr(0, found);
		break;

	case 3:
		found = str.find_last_of(L".");
		return str.substr(0, found);

	case 4:
		found = str.find_last_of(L".");
		return str.substr(found);

	case 6:
		found = str.find_last_of(L"/\\");
		return str.substr(found + 1);

	default:
		return str;

	}
}



int wmain(int argc, wchar_t *argv[])
{
	wchar_t szPath[MAX_PATH];
	wstring tPath;//path to this executable
	
	if (GetModuleFileName(NULL, szPath, MAX_PATH))
	{
		tPath.assign(szPath);
	}
		
	wstring outFile = FileNameExtract(tPath, 1);
	wstring fStr = L"\"";
	fStr.append(outFile);
	fStr.append(L"LoadSTL.zsc\"");

	//path to ZBrush	
	std::wstring zPathStr;
	zPathStr.assign(outFile);
	zPathStr.append(L"ZBrush_Path.txt");	
	wifstream fIn(zPathStr.c_str());
	if (!fIn)
	{
		return 2;//can't open file
	}
	wchar_t zbrushPath[MAX_PATH];
	fIn.getline(zbrushPath, MAX_PATH);
	fIn.close();


	outFile.append(L"ImportSTL.txt");
	wofstream fOut(outFile.c_str());
	if (!fOut)
	{
		return 1;
	}
	wstring sPth = argv[1];
	fOut << sPth.c_str() << endl;
	fOut.close();

	ShellExecute(NULL, L"open", zbrushPath, fStr.c_str(), NULL, SW_SHOWNORMAL);
    return 0;
}

